> For the complete documentation index, see [llms.txt](https://developers-apps-in-toss.toss.im/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/iap/iap.createonetimepurchaseorder.md).

# IAP.createOneTimePurchaseOrder

### 功能说明

会跳转到单次应用内支付订单页。支付·商品发放流程是 `options` / `onEvent` / `onError` 按事件风格选项处理。

* `options.sku`：是要下单的商品 ID。（`productId`已废弃）
* `options.processProductGrant`：在创建订单后发放商品时调用。将发放成功与否 `true`/`false`（或 Promise）返回。
* `onEvent`：支付成功时 `type: 'success'`以及结果数据调用。
* `onError`：在支付过程中发生错误时调用。

返回值 cleanup 函数在应用内支付功能结束后必须调用，以释放资源。

Toss App Android/iOS `5.219.0` 可在以上版本使用。若在不支持的版本中调用则 `UNSUPPORTED_APP_VERSION` 会发生错误。

### 类型

```ts
IAP.createOneTimePurchaseOrder(params: IapCreateOneTimePurchaseOrderOptions): () => void;
```

**Params**

```ts
interface IapCreateOneTimePurchaseOrderOptions {
  options: {
    sku: string;
    /** @deprecated 使用 sku */
    productId?: string;
    processProductGrant: (params: {
      orderId: string;
    }) => boolean | Promise<boolean>;
  };
  onEvent: (event: {
    type: "success";
    data: IapCreateOneTimePurchaseOrderResult;
  }) => void | Promise<void>;
  onError: (error: unknown) => void | Promise<void>;
}

interface IapCreateOneTimePurchaseOrderResult {
  orderId: string;
  displayName: string;
  displayAmount: string;
  amount: number;
  currency: string;
  fraction: number;
  miniAppIconUrl: string | null;
}
```

**Response**

在支付流程结束后调用以释放资源的 cleanup 函数(`() => void`）作为返回值。

### 错误

错误代码 `onError`可通过……接收，或由包裹调用的 `try/catch`中捕获到的错误的 `error.code` 值。

| 代码                                | 说明                                                                                                                            |
| --------------------------------- | ----------------------------------------------------------------------------------------------------------------------------- |
| `INVALID_PRODUCT_ID`              | 商品 ID 无效，或不存在该商品的情况。                                                                                                          |
| `PAYMENT_PENDING`                 | 支付仍在等待批准的情况。                                                                                                                  |
| `NETWORK_ERROR`                   | 因网络/服务器问题无法处理请求的情况。                                                                                                           |
| `INVALID_USER_ENVIRONMENT`        | 在特定设备·账户·设置下无法购买的商品。                                                                                                          |
| `ITEM_ALREADY_OWNED`              | 尝试再次购买已购买过的商品的情况。                                                                                                             |
| `APP_MARKET_VERIFICATION_FAILED`  | 已完成支付，但在应用商店验证失败的情况。                                                                                                          |
| `TOSS_SERVER_VERIFICATION_FAILED` | 已完成支付，但向服务器传输/保存失败的情况。                                                                                                        |
| `INTERNAL_ERROR`                  | 因服务器内部问题无法处理请求的情况。                                                                                                            |
| `KOREAN_ACCOUNT_ONLY`             | 在 iOS 上不是韩国账号的情况。                                                                                                             |
| `USER_CANCELED`                   | 用户离开订单页的情况。                                                                                                                   |
| `PRODUCT_NOT_GRANTED_BY_PARTNER`  | 合作方商品发放失败的情况。                                                                                                                 |
| `UNSUPPORTED_APP_VERSION`         | 如果当前运行的 Toss App 版本不支持此功能，调用后会立即发生。 `IAP.createOneTimePurchaseOrder.isSupported()`可通过它提前确认，发生时 `error.message`请向用户显示（更新提示文案）。 |

### 示例代码

```js
import { IAP } from "@apps-in-toss/web-framework";

const button = document.querySelector("#buy-button");
let cleanup;

button.addEventListener("click", () => {
  try {
    cleanup = IAP.createOneTimePurchaseOrder({
      options: {
        sku: "coin_100",
        processProductGrant: ({ orderId }) => {
          // 商品发放逻辑编写
          console.log("发放处理：", orderId);
          return true;
        },
      },
      onEvent: (event) => {
        console.log(event.type, event.data);
      },
      onError: (error) => {
        console.error(error);
      },
    });
  } catch (error) {
    console.error(error);
  }
});

// 离开页面时 cleanup?.()
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/iap/iap.createonetimepurchaseorder.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
